<template>
  <div class="wp-12 wp-layout wp-layout--no-pad wp-layout--form">
    <div class="wp-12 wp-layout wp-layout--no-pad">
      <wp-input class="wp-12" type="text" v-model="role.name"
        label="Название роли" placeholder="Введите название"/>
    </div>
    <div class="wp-12 wp-layout wp-layout--no-pad">
      <button class="wp-button wp-button--margin-right" @click="submit">
        Сохранить изменения
      </button>
      <button class="wp-button wp-button--cancel" @click="$emit('close')">
        Отменить
      </button>
    </div>
  </div>
</template>

<script>
import { mapActions } from 'vuex';

import WpInput from '@/components/WpInput.vue';

export default {
  name: 'Role',
  components: {
    WpInput,
  },
  data() {
    return {
      role: {
        name: '',
        display: false,
      },
    };
  },
  props: {
    data: {
      type: Object,
      default: () => undefined,
    },
  },
  methods: {
    ...mapActions('organization', ['createRole', 'updateRole']),
    submit() {
      if (this.$props.data) {
        this.editRole();
      } else {
        this.addRole();
      }
    },
    async addRole() {
      try {
        await this.createRole(this.role);
        this.$toasted.success('Роль создана');
        this.$emit('close');
      } catch (errors) {
        if (errors.length) {
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
        } else {
          this.$toasted.error('Неизветсная ошибка');
        }
      }
    },
    async editRole() {
      try {
        await this.updateRole(this.role);
        this.$toasted.success('Роль изменена');
        this.$emit('close');
      } catch (errors) {
        if (errors.length) {
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
        } else {
          this.$toasted.error('Неизветсная ошибка');
        }
      }
    },
  },
  created() {
    if (this.$props.data) {
      this.role = Object.assign({}, this.$props.data);
    }
  },
};
</script>

<style></style>
